//+------------------------------------------------------------------+
//|                                              AlgomojoButtons.mq4 |
//|           Copyright 2020, Marketcalls Financial Services Pvt Ltd |
//|                                       https://www.marketcalls.in |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, Marketcalls Financial Services Pvt Ltd"
#property link      "https://www.marketcalls.in"
#property version   "1.00"
#property strict


//Algomojo Autotrading Modules

input string user_apikey = "xxxxxxxxxxxxxxxxxxxxxx"; //Enter your API key here
input string api_secretkey = "xxxxxxxxxxxxxxxxxxxxxx"; //Enter your API secret key here
input string s_prdt_ali = "BO:BO||CNC:CNC||CO:CO||MIS:MIS||NRML:NRML";
input string Tsym = "CRUDEOIL21FEBFUT"; //Symbol Name
input string exch = "MCX"; //Exchange
input string Ret = "DAY"; //Retention
input string prctyp = "MKT"; // Pricetype
input string Pcode = "MIS"; // Product Code
input int qty = 100; // Quantity
input string AMO = "NO"; //AMO Order
input string stgy_name = "Metatrader Strategy"; // Strategy Name
input string broker = "ab"; //Broker Short code ab - aliceblue, tj- tradejini, zb - zebu , en - enrich
input string ver = "1.0"; //API Version

string response;
string api_data;

#import "AMMT4BRIDGE.dll"
     string AMDispatcher(string api_key, string api_secret, string api_name, string api_data, string br_code, string version);
#import

extern bool Enable_Algo = false;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   //if(IsTesting())
     {
      string name;
      string heading[4]={"Long Entry","Long Exit","Short Entry","Short Exit"};
      int xc=5;
      int yc=30;
      int xsize = 500;
      int ysize = 300;
      for(int i=0;i<4;i++)
        {
         name=heading[i];
         ObjectCreate(0,name,OBJ_BUTTON,0,0,0);
         ObjectSetText(name,name,16,"Arial",clrWhite);
         ObjectSetInteger(0,name,OBJPROP_XSIZE,xsize);
         ObjectSetInteger(0,name,OBJPROP_XSIZE,ysize);
         ObjectSetInteger(0,name,OBJPROP_XDISTANCE,xc);
         ObjectSetInteger(0,name,OBJPROP_YDISTANCE,yc);
         ObjectSetInteger(0,name,OBJPROP_COLOR,clrWhite);
         if(i==0)
         {
         ObjectSetInteger(0,name,OBJPROP_BGCOLOR,clrGreen);
         }
         if(i==1)
         {
         ObjectSetInteger(0,name,OBJPROP_BGCOLOR,clrTomato);
         }
         if(i==2)
         {
         ObjectSetInteger(0,name,OBJPROP_BGCOLOR,clrOrangeRed);
         }
         if(i==3)
         {
         ObjectSetInteger(0,name,OBJPROP_BGCOLOR,clrLime);
         }
         yc+=20;
        }

     }
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  //Delete the Buttons
  string ButtonName;
  string heading[4]={"Long Entry","Long Exit","Short Entry","Short Exit"};
  for(int i=0;i<4;i++)
        {
         ButtonName=heading[i];
         ObjectDelete(ButtonName);
         }
//---
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
  }

//+------------------------------------------------------------------+
//| BuyOrder  function                                               |
//+------------------------------------------------------------------+  

  
void BuyOrder()
   {
  
     //Algomojo Place Buy Order


      api_data ="{\"stgy_name\":\""+stgy_name+"\",\"s_prdt_ali\":\""+s_prdt_ali+"\",\"Tsym\":\""+Tsym+"\",\"exch\":\""+exch+"\",\"Ttranstype\":\""+"B"+"\",\"Ret\":\""+Ret+"\",\"prctyp\":\""+prctyp+"\",\"qty\":\""+qty+"\",\"discqty\":\""+"0"+"\",\"MktPro\":\""+"NA"+"\",\"Price\":\""+"0"+"\",\"TrigPrice\":\""+"0"+"\",\"Pcode\":\""+Pcode+"\",\"AMO\":\""+AMO+"\"}";
         
      response=AMDispatcher(user_apikey, api_secretkey,"PlaceOrder",api_data,broker,ver);
      Print("api : " ,api_data);
      Print("Algomojo Buy Order response : " ,response);
      
      
    }


//+------------------------------------------------------------------+
//| SellOrder  function                                              |
//+------------------------------------------------------------------+    
    
void SellOrder()
   {
  
      //Algomojo Place Sell Order
      api_data ="{\"stgy_name\":\""+stgy_name+"\",\"s_prdt_ali\":\""+s_prdt_ali+"\",\"Tsym\":\""+Tsym+"\",\"exch\":\""+exch+"\",\"Ttranstype\":\""+"S"+"\",\"Ret\":\""+Ret+"\",\"prctyp\":\""+prctyp+"\",\"qty\":\""+qty+"\",\"discqty\":\""+"0"+"\",\"MktPro\":\""+"NA"+"\",\"Price\":\""+"0"+"\",\"TrigPrice\":\""+"0"+"\",\"Pcode\":\""+Pcode+"\",\"AMO\":\""+AMO+"\"}";
         
      response=AMDispatcher(user_apikey, api_secretkey,"PlaceOrder",api_data,broker,ver);
      Print("api : " ,api_data);
      Print("Algomojo Sell Order response : " ,response);
         
   
   
   }
  
   
  
  
  
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
  
      if(ObjectGetInteger(0,"Long Entry",OBJPROP_STATE)==true)
        {
        if(Enable_Algo){
         //Algomojo Place Buy Order - Double the Quantity

         ObjectSetInteger(0,"Long Entry",OBJPROP_STATE,false);
         BuyOrder();
         }
        }
     
      if(ObjectGetInteger(0,"Short Entry",OBJPROP_STATE)==true)
        {
         if(Enable_Algo){
         //Algomojo Place Buy Order - Double the Quantity
         ObjectSetInteger(0,"Short Entry",OBJPROP_STATE,false);
         SellOrder();
         }
        }
      
      if(ObjectGetInteger(0,"Long Exit",OBJPROP_STATE)==true)
        {
         if(Enable_Algo){
         //Algomojo Place Buy Order - Double the Quantity
         ObjectSetInteger(0,"Long Exit",OBJPROP_STATE,false);
         SellOrder();
         }
        }
      
      if(ObjectGetInteger(0,"Short Exit",OBJPROP_STATE)==true)
        {
         if(Enable_Algo){
         //Algomojo Place Buy Order - Double the Quantity
         ObjectSetInteger(0,"Short Exit",OBJPROP_STATE,false);
         BuyOrder();
         }
        }
     }
     
     
     
     
//---
 
  }